#ifndef WINDOW_H
#define WINDOW_H

#include <GL/glew.h>
#include <GLFW/glfw3.h>

#include "utils/Size.h"
#include "input/Controller.h"
#include "rendering/Options.h"

class Window final {
    GLFWwindow* window;
    Size& size;
    Controller& controller;

public:
    Window(Size& size, Controller& controller, const Options& options);
    ~Window();

    Window(const Window&) = delete;
    Window& operator=(const Window&) = delete;
    Window(Window&&) = delete;
    Window& operator=(Window&&) = delete;

    bool hasError() const;
    void show();
    bool shouldClose() const;
    void swapBuffers();
};

#endif